/*
  file:         Basis_table_print.cc
  created:      David P Jacobs May 1990
  modified:     pasha sep 7 2015,feb 10,13-14,18,27-28,mar 7,10,12-13 2016
  modification: - removed output pagination
                - support for dmalloc
				- C++ file extensions 
*/

#include <stdio.h>
#include "albert.hh"

#ifdef DMALLOC
#include <dmalloc.h>
#endif

extern unsigned int Nextbasistobefilled;


void Albert::PrintBasis (const Basis b, std::ostream& os) const
{
  if ((this->Basis_table[b].left_factor  == 0) && 
	  (this->Basis_table[b].right_factor == 0))
	{
	  os << GetLetterofBasis (b);
	}
  else 
	{
	  os << "(";
	  this->PrintBasis (this->Basis_table[b].left_factor,  os);
	  this->PrintBasis (this->Basis_table[b].right_factor, os);
	  os << ")";
    }
}




void Albert::PrintBasisTable (std::ostream& os) const
{
  if (this->Basis_table.size() > 0)
	{
	  os << "Basis Table: " << std::endl;
	  for (unsigned int i=1; i < this->Basis_table.size(); i++) 
		{
		  os << " " << std::setw(3) << i << ".   " 
			 << std::setw(3) << this->Basis_table[i].left_factor  << " " 
			 << std::setw(3) << this->Basis_table[i].right_factor << "   ";
		  PrintTypeName (this->Basis_table[i].type, os);
		  os << "    ";
		  this->PrintBasis (i, os);
		  os << std::endl;
		}
	}
}


// end of Basis_table_print.cc
