/*
  file:         PerformSub.hh
  created:      Sekhar Muddana May 1990
  modified:     Pasha Zusmanovich feb 18,20,24,27,mar 9,14 2016
  modification: c++ file ext.; attempt to template Scalar; include once
*/

#ifndef __PERFORM_SUB_H
#define __PERFORM_SUB_H

#include "Po_parse_exptext.hh"

template<typename T> struct Basis_pair_node
{
  Basis_pair<T> bp;
  struct Basis_pair_node<T>* next;
};


typedef int* Perm;

Perm GetFirstPermutation (const int);
Perm GetNextPermutation  (Perm, int);



template<typename T> Basis_pair_node<T>* GetNewBPNode()
{
  Basis_pair_node<T>* temp_node = 
	(Basis_pair_node<T>*)(Mymalloc (sizeof(Basis_pair_node<T>)));
  if (temp_node != NULL) 
	{
	  new (&((temp_node->bp).coef)) T;  // "placement new"
	  (temp_node->bp).coef = (T)0;
	  (temp_node->bp).left_basis  = 0;     
	  (temp_node->bp).right_basis = 0;     
	  temp_node->next = NULL;
	}
  return (temp_node);
}



template<typename T> bool FreeLocalList (Basis_pair_node<T>* Ll)
{
  assert_not_null(Ll);
  if (Ll->next == NULL)
	{
	  free (Ll);
	}
  else 
	{
	  FreeLocalList<T> (Ll->next);
	  free (Ll);
    }
  return (1);
}




#endif // __PERFORM_SUB_H
// end of PerformSub.hh
