/*
  file:         Po_syn_stack.cc
  purpose:      routines which manipulate Syntax stack.
                These routines are called by the module 
    	        Po_parse_poly.c while doing the parsing.
  created:      Sekhar Muddana circa 1990
  modified:     pasha dec 31 2018
  modification: removed Print_syn_stack()
*/

#include <iostream>
#include "Po_syn_stack.hh"	


// MODIFIES: Stack -- Syntax stack
//           Sp_ptr -- Syntax stack pointer
// args: token -- to be pushed onto the stack
void Push_token (int Stack[], int* Sp_ptr, int Token)
{
  if (*Sp_ptr < STACK_SIZE - 1)
	{
	  Stack[++(*Sp_ptr)] = Token;
	}
  else
	{
	  std::cout << " Stack full" << std::endl;
	}
}


// args: Stack -- Syntax stack
//       Sp    -- Syntax stack pointer
// RETURNS: Token at the top of the stack
int Get_top_token (int Stack[], int Sp)
{
  return (Stack[Sp]);
}


// args: Stack -- Syntax stack
//       Sp    -- Syntax stack pointer
// RETURNS: Token at second from the top of the Stack
int Get_next_to_top_token (int Stack[], int Sp)
{
  return (Stack[Sp-1]);
}



// MODIFIES: Stack -- Syntax stack
//           Sp_ptr -- Syntax stack pointer
// RETURNS: Token popped from the top of the Stack
int Pop_token (int Stack[], int* Sp_ptr)
{
  if ((*Sp_ptr >= 0) && (*Sp_ptr < STACK_SIZE))
	{
	  return (Stack[(*Sp_ptr)--]);
	}
  else
	{
	  std::cout << "Stack index out of bounds" << std::endl;
	  return (-1);
	}
}


// Print the tokens stored in the stack
// args: Stack -- Syntax stack
//       Sp    -- Syntax stack pointer
/*
void Print_syn_stack (int Stack[], int Sp)
{
  for (int i=0; i <= Sp; i++)
	{
	  std::cout << "Stack[" << i << "] = " << Stack[i] << std::endl;
	}
}
*/


// end of Po_syn_stack.cc
