/*
  file:         node_mgt.hh
  created:      David P. Jacobs May 1990
  modified:     Pasha Zusmanovich feb 18,27,mar 1,10 2016
  modification: c++ file ext.; include once; Scalar templated
*/

// The include file for the memory mgt routines in node_mgt.c. 
// The #define RECORDS_PER_BLOCK is the number of node records per allocated 
// block of memory.
// 8190 is chosen because it is near a 64 K boundary and this should make the 
// system call to malloc perform better.

#ifndef __NODE_MGT_H
#define __NODE_MGT_H

#include "Build_defs.hh"
#include "Sparse_structs.hh"

#define RECORDS_PER_BLOCK  8190

template<typename T> struct mem_block 
{
  Node<T> record[RECORDS_PER_BLOCK];
  struct mem_block<T>* next_block;
#ifdef DEBUGMM
  short int id;
#endif
};


#endif // __NODE_MGT_H
// end of node_mgt.hh

