#!/bin/bash
#
# file:         test_albert.sh
# created:      pasha mar 27 2012
# modified:     pasha feb 10-11,28,may 1 2016
# modification: options for diff, -a option for albert
#
# this simple script runs albert feeding it as inputs
# all the files sitting in the subdir 'tests', and comparing
# with respective canonical (trimmed) outputs sitting in the subdir 'out'


cd tests
for f in *[^~]; do
	echo running $f 
	../../albert -a ../.. 2>/dev/null < $f | ../trim_albert_out.pl > ${f}.out.tmp
	# -Z option not valid in diff 2.8.1
	diff -awB ${f}.out.tmp ../out/${f}.out
	rm ${f}.out.tmp
done

# end of test_albert.sh
