#!/usr/bin/perl
#
# file:         trim_albert_out.pl
# purpose:      trim albert output of run-dependent details (date, elapsed time)
# created:      pasha mar 27 2012
# modified:     pasha mar 13,may 1,16 2016
# modification: sync with current albert output
# usage:        reads from stdin, writes to stdout
#

use strict;
use warnings;

for (<>)
  {
	# remove albert version and year
	s/ version (.*) 2[0-9][0-9][0-9]//;

	# remove .albert file location in "can't open file" message
	s/^Can\'t open (.*)\/\.albert file.\w*//;
	s/^Using (.*)\/\.albert\w*//;

	# remove run date
	s/^Build begun at .*/Build begun at /;

	# remove comments in input ignored by albert
	s/^-->#.*//;

	# remove elapsed time
	s/^((\s+)[1-9][0-9]*(\s+)[1-9][0-9]*(\s+))[0-9]+(\s+)$/$1\n/;

	print ${_};
  }

exit;

__END__
